//----------------------------------------------------------------------------
//
//  This file is part of seq24.
//
//  seq24 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  seq24 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with seq24; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//-----------------------------------------------------------------------------

#include "options.h"

options::options( perform *a_p )
{
    m_perf = a_p;

    set_title ("options");

    get_action_area()->set_border_width( 2 );
    get_vbox()->set_border_width( 6 );

    m_button_ok = manage( new Button( " Ok " ) );
    get_action_area()->pack_end( *m_button_ok, false, false );
    m_button_ok->clicked.connect( hide.slot() );

    m_frame_clock = manage( new Frame( "Midi Clock" ));
    get_vbox()->pack_start( *m_frame_clock, false, false );

    int buses = m_perf->get_master_midi_bus( )->get_num_out_buses();

    VBox *vbox = manage( new VBox( ));
    m_frame_clock->add( *vbox );

    for ( int i=0; i<buses; i++ ){

	CheckButton *check = manage( new CheckButton(  m_perf->get_master_midi_bus( )->get_bus( i )->get_name(), 0 ));
	check->toggled.connect( bind(slot(this,&options::clock_callback), i, check ));
	check->set_active( m_perf->get_master_midi_bus( )->get_bus( i )->get_clock(  ));

	vbox->pack_start( *check, false, false );
    }

    /* show everything */
    show_all();
}


void
options::clock_callback( int a_bus, CheckButton *a_button )
{
    bool clocking = a_button->get_active( );
    m_perf->get_master_midi_bus( )->get_bus( a_bus )->set_clock( clocking );
}


